<template>
  <ck-base-item-bis
    :tabindex="tabindex"
    :item-id="item.id"
    :label="item.label"
    :checked="isCompleted"
    :focus-on-mount="focusOnMount"
    :collection-id="collectionId"
    :apparitionOrder="item.ordre"
    @setup-create="$emit('setup-create')"
    @setup-edit="setupEdit"
    @item-update="update"
  >
  <template #checkbox="{ color }">
      <v-progress-circular :color="color"  size="25" width="5" :model-value="pourcentage"></v-progress-circular>
    </template>
    <template #edit>
      <group-item-form
        v-model="editingItem"
      ></group-item-form>
    </template>
    <template #mobileComplement>
      <v-btn
        block
        size="large"
        color="surface-lighten-1"
        prepend-icon="mdi-eye"
        @click="$emit('clicked')"
      >Voir la liste compléte</v-btn>
    </template>
  </ck-base-item-bis>
</template>

<script setup>
import CkBaseItemBis from '@/components/item/ck-base-item.vue'
import GroupItemForm from '@/components/item/group/group-item-form.vue'
</script>

<script>
import { mapState } from 'pinia'
import { useCollectionsStore } from '@/stores/itemCollections.js'
import { toRaw } from 'vue'
export default {
  name:"group-item",
  props: {
    item: {
      type: Object,
      required: true
    },
    tabindex: {
      type: Number,
      required: true
    },
    focusOnMount:  {
      type: Boolean,
      default: false
    },
    collectionId:  {
      type: String,
      required: true
    },
  },
  data() {
    return {
      editingItem: {}
    }
  },
  computed: {
    ...mapState(useCollectionsStore, {
      getByCollectionId: 'getByCollectionId',
    }),
    isCompleted() {
      return this.loaded && this.collection.nbCompletedItems === this.collection.nbItems
    },
    collection() {
      return this.getByCollectionId(this.item.itemCollectionId)
    },
    loaded() {
      return this.collection !== undefined
    },
    pourcentage() {
      return this.loaded ? (100*this.collection.nbCompletedItems)/this.collection.nbItems : 0
    },
  },
  methods: {
    setupEdit() {
      this.editingItem = structuredClone(toRaw(this.item))
    },
    update() {
      useCollectionsStore().updateGroupItem(this.collectionId, this.item.id, this.editingItem)
    }
  },
  created() {
    useCollectionsStore().fetchCollection(this.item.itemCollectionId)
  },
}
</script>
